## ipu6-camera-hal 0~git202501070628.8346d93~ubuntu24.04.2

=== CMakeLists.txt ===
#
#  Copyright (C) 2017-2024 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

cmake_minimum_required(VERSION 2.8)

project(libcamhal)

option(BUILD_CAMHAL_PLUGIN "Build libcamhal as plugins" OFF)
option(BUILD_CAMHAL_ADAPTOR "Build hal_adaptor as libcamhal" OFF)

#------------------------- Global settings -------------------------

#------------------------- folder settings -------------------------

# Source directories
set(SRC_ROOT_DIR        ${CMAKE_CURRENT_LIST_DIR}/src)

set(3A_DIR              ${SRC_ROOT_DIR}/3a)
set(CORE_DIR            ${SRC_ROOT_DIR}/core)
set(HAL_DIR             ${SRC_ROOT_DIR}/hal)
set(IIO_DIR             ${SRC_ROOT_DIR}/iio)
set(IUTILS_DIR          ${SRC_ROOT_DIR}/iutils)
set(SCHEDULER_DIR       ${SRC_ROOT_DIR}/scheduler)
set(METADATA_DIR        ${SRC_ROOT_DIR}/metadata)
set(PLATFORMDATA_DIR    ${SRC_ROOT_DIR}/platformdata)
set(V4L2_DIR            ${SRC_ROOT_DIR}/v4l2)
set(MODULES_DIR         ${CMAKE_CURRENT_LIST_DIR}/modules)
set(ALGOWRAPPER_DIR     ${MODULES_DIR}/algowrapper)
set(SANDBOXING_DIR      ${MODULES_DIR}/sandboxing)
set(IMAGE_PROCESS_DIR   ${SRC_ROOT_DIR}/image_process)

#AAL directories
if (CAL_BUILD)
    set(AAL_ROOT_DIR       ${CMAKE_CURRENT_LIST_DIR}/aal)
    set(JPEG_DIR           ${SRC_ROOT_DIR}/jpeg)
    set(MEMORY_DIR         ${MODULES_DIR}/memory)
endif() #CAL_BUILD

if (SUPPORT_LIVE_TUNING)
    #LiveTuning directories
    set(LIVE_TUNING_DIR         ${MODULES_DIR}/livetune)
endif() #SUPPORT_LIVE_TUNING

# ia_cipr is only used by psysprocessor
if (USE_PG_LITE_PIPE)
    set(IA_CIPR_DIR         ${MODULES_DIR}/ia_cipr)
    set(MODULE_IA_CSS_DIR   ${MODULES_DIR}/ia_css)
endif() #USE_PG_LITE_PIPE

# CMake module directory
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Install directories
# CMAKE_INSTALL_PREFIX is defined when executing cmake and supposed to be ./out/libcamhal
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "Target location for install command." FORCE)
endif()

#------------------------- compile and link options -------------------------

include(GNUInstallDirs)
# code coverage.
include(code-coverage)

message(STATUS "install prefix: " ${CMAKE_INSTALL_PREFIX})

set (CMAKE_CXX_STANDARD 11)
add_compile_options(
    -Wall
    -Werror
    -fstack-protector
    -fPIE
    -fPIC
    -DDCHECK_ALWAYS_ON
    -Wformat
    -Wformat-security
)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-faligned-new COMPILER_SUPPORTS_ALIGNED_NEW)
if (COMPILER_SUPPORTS_ALIGNED_NEW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -faligned-new")
endif()

set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package (Threads REQUIRED)

# check if _FORTIFY_SOURCE is default defined with -O
include(CheckFortifyLevel)
set(FORTIFY_SOURCE_VALUE)
check_fortify_source(FORTIFY_SOURCE_VALUE)
if(FORTIFY_SOURCE_VALUE)
    message(STATUS "compiler default _FORTIFY_SOURCE=${FORTIFY_SOURCE_VALUE}")
else()
    message(STATUS "_FORTIFY_SOURCE is not defined or could not be determined.")
    add_compile_options(-D_FORTIFY_SOURCE=2)
    message(STATUS "define _FORTIFY_SOURCE=2")
endif()

add_link_options(
    -fPIE
    -fPIC
    -Wformat
    -Wformat-security
    -Wl,-z,relro
    -Wl,-z,now
    -Wl,--no-as-needed
    -Wl,--no-undefined
)

# -fPIC in xos way
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

#------------------- common definitions, includes and link --------------------

add_definitions(-D__STDC_FORMAT_MACROS -DHAVE_PTHREADS -DHAVE_LINUX_OS -DHAVE_IA_TYPES -DHAVE_PRCTL)

include_directories(
    include
    include/api include/utils
    ${CMAKE_INSTALL_PREFIX}/include/ia_camera
    ${CMAKE_INSTALL_PREFIX}/include/
    ${CMAKE_CURRENT_LIST_DIR}
    src
    src/v4l2 src/core src/metadata
    src/platformdata src/platformdata/gc
    src/3a src/3a/intel3a src/3a/external
    src/fd src/scheduler
    src/core/psysprocessor
    src/image_process
)

set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} expat rt)

add_subdirectory(src)
add_subdirectory(modules)

if (USE_PG_LITE_PIPE)
    add_definitions(-DUSE_PG_LITE_PIPE)
endif() #USE_PG_LITE_PIPE

    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${IIO_SRCS})

if (SUPPORT_LIVE_TUNING)
    include_directories(modules/livetune)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${LIVE_TUNING_SRCS})
endif() #SUPPORT_LIVE_TUNING

if(FACE_DETECTION)
    add_definitions(-DFACE_DETECTION)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${FACE_DETECTION_SRCS})
    set(LIBCAMHAL_LINK_LIBS
        ${LIBCAMHAL_LINK_LIBS}
        pvl_eye_detection
        pvl_face_detection
        pvl_mouth_detection
        ${WORK_DIR_TMP}/src/fd/libface_detection.a
    )
endif() #FACE_DETECTION

if(ENABLE_SANDBOXING)
    find_package(LIBMOJO)
    find_package(LIBCAMERA_IPC)
    find_package(LIBCAB)
    add_definitions(-DENABLE_SANDBOXING)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${SANDBOXING_CLIENT_SRCS})
    include_directories(
        ${USR_INCLUDE_HEADER}/base-${BASEVER}
        ${LIBMOJO_INCLUDE_DIRS}
        ${LIBCAMERA_IPC_INCLUDE_DIRS}
        ${LIBCAB_INCLUDE_DIRS}
    )
    link_directories(
        ${CMAKE_PREFIX_PATH}
        ${LIBMOJO_LIBS}
        ${LIBCAMERA_IPC_LIBS}
        ${LIBCAB_LIBS}
    )
    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBCAB_LIBS} ${LIBMOJO_LIBS} ${LIBCAMERA_IPC_LIBS} ${CMAKE_PREFIX_PATH}/librt.a)
endif() #ENABLE_SANDBOXING

if (CAL_BUILD)
    message("Chrome enabled ")
    add_definitions(-DCAL_BUILD -DDUMP_IMAGE)
    if (SW_JPEG_ENCODE)
        add_definitions(-DSW_JPEG_ENCODE)
        include_directories(src/jpeg/sw)
    else ()
        include_directories(src/jpeg/chrome)
    endif()

    if (SW_POST_PROCESSING)
        include_directories(src/image_process/sw)
    else ()
        include_directories(src/image_process/chrome)
    endif()

    add_subdirectory(aal)

    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${MEMORY_SRCS} ${AAL_SRCS} ${JPEG_SRCS})
    include_directories(include include/api include/utils include/linux
        ${USR_INCLUDE_HEADER}/android/system/core/include/
        ${USR_INCLUDE_HEADER}/ia_imaging
        ${USR_INCLUDE_HEADER}/usr/lib${IPU_VER}
        ${USR_INCLUDE_HEADER}/android/hardware/libhardware/include/
        aal aal/chrome src/iutils src/jpeg
        modules/memory modules/memory/chrome
    )
    find_package(LIBCAMERA_CLIENT)
    find_package(LIBCAMERA_COMMON)
    find_package(LIBCAMERA_METADATA)
    find_package(LIBCAMERA_V4L2_DEVICE)
    find_package(LIBSYNC)
    find_package(LIBCBM)

    include_directories(${LIBCAMERA_CLIENT_INCLUDE_DIRS} ${LIBCAMERA_COMMON_INCLUDE_DIRS}
                        ${LIBCAMERA_METADATA_INCLUDE_DIRS} ${LIBCAMERA_V4L2_DEVICE_INCLUDE_DIRS}
                        ${LIBSYNC_INCLUDE_DIRS}
                        ${LIBCBM_INCLUDE_DIRS}
                        )
    link_directories(${CMAKE_PREFIX_PATH} ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_METADATA_LIBS}
                     ${LIBCAMERA_COMMON_LIBS} ${LIBSYNC_LIBS}
                     ${LIBCBM_LIBS}
                     )

    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_COMMON_LIBS}
                          ${LIBCAMERA_METADATA_LIBS} ${LIBCAMERA_V4L2_DEVICE_LIBS}
                          ${LIBSYNC_LIBS} jpeg ${CMAKE_PREFIX_PATH}/libyuv.pic.a
                          ${LIBCBM_LIBS} camera_v4l2_device
                          )
endif() #CAL_BUILD

if (NOT CAL_BUILD)
    message("Linux build")
    add_definitions(-DSUPPORT_MULTI_PROCESS)
    add_definitions(-DLINUX_BUILD)
    include_directories(${MODULES_DIR}/v4l2)
    find_package(LIBDRM)
    if(LIBDRM_FOUND AND ("${LIBDRM_VERSION}" VERSION_GREATER_EQUAL 2.4.114))
        include_directories(${LIBDRM_INCLUDE_DIRS})
        set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBDRM_LIBS})
        add_definitions(-DLIBDRM_SUPPORT_MMAP_OFFSET)
    endif()
endif()

set(LIBCAMHAL_SRCS
    ${LIBCAMHAL_SRCS}
    ${3A_SRCS}
    ${CORE_SRCS}
    ${HAL_SRCS}
    ${IPS_CTRL_SRCS}
    ${IUTILS_SRCS}
    ${METADATA_SRCS}
    ${PLATFORMDATA_SRCS}
    ${SCHEDULER_SRCS}
    ${V4L2_SRCS}
    ${ALGOWRAPPER_SRCS}
    ${IMAGE_PROCESS_SRCS}
    ${MODULES_DIR}/ia_cipr/src/Buffer.cpp
    ${MODULES_DIR}/ia_cipr/src/Context.cpp
    ${MODULES_DIR}/ia_cipr/src/Event.cpp
    ${MODULES_DIR}/ia_cipr/src/Command.cpp
    ${MODULES_DIR}/ia_cipr/src/Utils.cpp
)

#------------------------- Target settings -------------------------

if (NOT IPU_VERSIONS)
    set(IPU_VERSIONS ${IPU_VER})
endif()

if (BUILD_CAMHAL_ADAPTOR)
    add_subdirectory(src/hal/hal_adaptor)
    if (NOT BUILD_CAMHAL_PLUGIN)
        message(NOTICE "Will not build libcamhal plugins")
        set(IPU_VERSIONS "")
    endif()
endif()

# Add different targets according to array IPU_VERSIONS
foreach(IPU_VER ${IPU_VERSIONS})

if (BUILD_CAMHAL_PLUGIN)
    set(TARGET_SUFFIX "-${IPU_VER}")
endif()

set(TARGET_INCLUDE "")
set(TARGET_DEFINITIONS "")
set(TARGET_SRCS "")
set(TARGET_LINK_LIBS "")

if (USE_PG_LITE_PIPE)
    add_subdirectory(modules/ia_css modules/ia_css${TARGET_SUFFIX})
    set(TARGET_INCLUDE ${TARGET_INCLUDE} ${MODULE_IA_CSS_HEADER_INCLUDE_DIR})
    set(TARGET_SRCS ${TARGET_SRCS} ${MODULE_IA_CSS_SRC})
endif() #USE_PG_LITE_PIPE

if (IPU_VER MATCHES "ipu6")
    message(STATUS "add definition -DIPU_SYSVER_IPU6 for ${IPU_VER}")
    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_IPU6)
    if (IPU_VER STREQUAL "ipu6sepla")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v3 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v3)
    elseif (IPU_VER STREQUAL "ipu6ep")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v5 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v5)
    elseif (IPU_VER STREQUAL "ipu6epmtl")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v6 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v6)
    endif()
endif()

if (NOT CAL_BUILD)
    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
endif()

# Link libraries, the building will be interrupted if libs/includes not found
    # Link ia_imaging
    find_package(IA_IMAGING)
    set(TARGET_INCLUDE ${TARGET_INCLUDE} ${IA_IMAGING${TARGET_SUFFIX}_INCLUDE_DIRS})
    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBS})

    if(USE_PG_LITE_PIPE)
        find_package(LIBGCSS)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBGCSS${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBS})
        # Include libipu(4) headers
        find_package(LIBIPU)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIPU${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBS})
    else()
        # Link libiacss
        find_package(LIBIACSS)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIACSS${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBS})
    endif()

#--------------------------- Add libcamhal target  ---------------------------

if (BUILD_CAMHAL_PLUGIN)
    set(CAMHAL_TARGET ${IPU_VER})
    set(CAMHAL_STATIC_TARGET ${IPU_VER}_static)
else()
    set(CAMHAL_TARGET camhal)
    set(CAMHAL_STATIC_TARGET camhal_static)
endif()

# Add libcamhal using the specified sources

=== src/hal/CMakeLists.txt ===
#
#  Copyright (C) 2017 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(HAL_SRCS
    ${HAL_DIR}/CameraHal.cpp
    ${HAL_DIR}/ICamera.cpp
    CACHE INTERNAL "hal sources"
    )

=== src/hal/hal_adaptor/CMakeLists.txt ===
#
#  Copyright (C) 2023-2024 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

# Source directories
set(ROOT_DIR        ${CMAKE_CURRENT_LIST_DIR}/../../../)
set(METADATA_DIR    ${ROOT_DIR}/src/metadata)
set(IUTILS_DIR      ${ROOT_DIR}/src/iutils)
set(HAL_ADAPTOR_DIR ${ROOT_DIR}/src/hal/hal_adaptor)

set(HAL_ADAPTOR_INCLUDEDIRS
    ${ROOT_DIR}/include
    ${ROOT_DIR}/include/api
    ${ROOT_DIR}/include/utils
    ${ROOT_DIR}/src/metadata
    ${ROOT_DIR}/src/iutils
    ${ROOT_DIR}/src/core
    ${ROOT_DIR}/src/platformdata
    ${ROOT_DIR}/src/isp_control
    ${ROOT_DIR}/src
    ${ROOT_DIR}/modules/v4l2
    ${ROOT_DIR}
    )

set(HAL_ADAPTOR_SRCS
    ${METADATA_DIR}/icamera_metadata_base.cpp
    ${METADATA_DIR}/CameraMetadata.cpp
    ${METADATA_DIR}/Parameters.cpp
    ${METADATA_DIR}/ParameterHelper.cpp
    ${IUTILS_DIR}/CameraLog.cpp
    ${IUTILS_DIR}/LogSink.cpp
    ${IUTILS_DIR}/ModuleTags.cpp
    ${IUTILS_DIR}/Trace.cpp
    ${IUTILS_DIR}/Utils.cpp
    ${IUTILS_DIR}/ScopedAtrace.cpp
    ${HAL_ADAPTOR_DIR}/HalAdaptor.cpp
    CACHE INTERNAL "hal adaptor sources"
)

add_library(hal_adaptor SHARED ${HAL_ADAPTOR_SRCS})
target_include_directories(hal_adaptor PRIVATE ${HAL_ADAPTOR_INCLUDEDIRS})
target_compile_definitions(hal_adaptor PRIVATE
                           -D__STDC_FORMAT_MACROS
                           -DHAVE_PTHREADS
                           -DHAVE_LINUX_OS
                           "-DCAMHAL_PLUGIN_DIR=\"${CMAKE_INSTALL_FULL_LIBDIR}/libcamhal/plugins/\""
                           )
set_target_properties(hal_adaptor PROPERTIES OUTPUT_NAME camhal)
set_target_properties(hal_adaptor PROPERTIES SOVERSION 0)
set_target_properties(hal_adaptor PROPERTIES VERSION "0.0.0")

#---------------------------- Link settings ----------------------------
set (THREADS_PREFER_PTHREAD_FLAG ON)
find_package (Threads REQUIRED)
target_link_libraries(hal_adaptor ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(hal_adaptor ${CMAKE_DL_LIBS})
target_link_libraries(hal_adaptor rt)

# Install headers
install(DIRECTORY ${ROOT_DIR}/include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libcamhal)
if (SUPPORT_LIVE_TUNING)
    install(FILES ${ROOT_DIR}/modules/livetune/LiveTuning.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libcamhal/api)
endif()

# Install libraries
if (${CMAKE_VERSION} VERSION_LESS 3.11)
    install(TARGETS hal_adaptor
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            )
else()
    install(TARGETS hal_adaptor DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Install package config file
configure_file(${PROJECT_SOURCE_DIR}/cmake/libcamhal.pc.cmakein
               ${PROJECT_SOURCE_DIR}/libcamhal.pc @ONLY)
install(FILES ${PROJECT_SOURCE_DIR}/libcamhal.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
ipu6-camera-hal (0~git202501070628.8346d93~ubuntu24.04.2) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Fri, 24 Jan 2025 01:31:14 +0000

ipu6-camera-hal (0~git202411151015.7527bcc-1) UNRELEASED; urgency=medium

  [ Kai-Chuan Hsieh ]
  * debian: Add transitional package for ipu6ep series
  * debian: Add libcamhal-ipu6ep-common.preinst script to remove contents
  * Add modalias for IPU controllers
  * debian: Add support for LNL platform
  * debian: Add support for ARL platforms

  [ Shih-Yuan Lee (FourDollars) ]
  * debian: Fix a typo.
  * debian: Refactor to adopt the main branch.

 -- Shih-Yuan Lee (FourDollars) <sylee@canonical.com>  Thu, 28 Nov 2024 17:18:08 +0800

=== debian/control ===
Source: ipu6-camera-hal
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 dh-modaliases,
 libdrm-dev,
 libexpat-dev,
 libipu6-dev (>= 0~git202309010954.376fccf~),
 libipu6ep-dev (>= 0~git202309010954.376fccf~),
 libipu6epmtl-dev (>= 0~git202309010954.376fccf~),
 pkg-config,
Standards-Version: 4.5.0
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Vcs-Browser: https://github.com/intel/ipu6-camera-hal
Vcs-Git: https://github.com/intel/ipu6-camera-hal.git

Package: libcamhal0
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-common (= ${source:Version}),
Breaks:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep0 (<= 0~git202309010954.7964af4~),
Recommends:
 gstreamer1.0-icamera, v4l2-relayd
Description: HAL library for MIPI camera through Intel IPU6
 This package contains the main runtime library on Intel IPU6 platform.

Package: libcamhal-common
Architecture: all
Depends:
 ${misc:Depends},
Breaks:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-common (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - common files
 This package contains default camera settings on Intel IPU6 platform.

Package: libcamhal-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 pkg-config,
Breaks:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Replaces:
 libcamhal-ipu6ep-dev (<= 0~git202309010954.7964af4~),
Description: HAL library for MIPI camera through Intel IPU6 - development kit
 This package contains development files for libcamhal0 on Intel IPU6 platform.

Package: libcamhal-ipu6
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6) - development kit
 This package contains development files for libcamhal-ipu6.

Package: libcamhal-ipu6ep
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6ep-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6ep)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6ep-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6ep)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6ep-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6ep) - development kit
 This package contains development files for libcamhal-ipu6ep.

Package: libcamhal-ipu6epmtl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal0 (= ${binary:Version}),
 libcamhal-ipu6epmtl-common (= ${binary:Version}),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for IPU6 camera (ipu6epmtl)
 This package contains the main runtime library on Intel IPU6 platform.
 The HAL library will load this plugin at runtime.

Package: libcamhal-ipu6epmtl-common
Architecture: all
Depends: libcamhal-common (= ${binary:Version})
Description: Common files for for MIPI camera through Intel IPU6 (ipu6epmtl)
 This package contains default camera settings on Intel IPU6 platform.
 The physical camera needs the settings to be configured on the host.

Package: libcamhal-ipu6epmtl-dev
Architecture: any
Depends: libcamhal-dev (= ${binary:Version})
Description: Dynamic loading plugin for IPU6 camera (ipu6epmtl) - development kit
 This package contains development files for libcamhal-ipu6epmtl.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

configure_args = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_LIBDIR=lib \
	-DBUILD_CAMHAL_ADAPTOR=ON \
	-DBUILD_CAMHAL_PLUGIN=ON \
	-DUSE_STATIC_GRAPH=ON \
	-DUSE_STATIC_GRAPH_AUTOGEN=ON \
	-DUSE_PG_LITE_PIPE=ON \
	$(empty)

targets = ipu6 ipu6ep ipu6epmtl
versions = "ipu6;ipu6ep;ipu6epmtl"

%:
	dh $@ --with modaliases

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- \
		-DIPU_VERSIONS=$(versions) $(configure_args); \

override_dh_auto_install:
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
		debian/libcamhal0.install.in > debian/libcamhal0.install
	sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
		debian/libcamhal-dev.install.in > debian/libcamhal-dev.install
	for ipu_ver in $(targets); do \
		sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			debian/libcamhal-$${ipu_ver}-dev.install.in > debian/libcamhal-$${ipu_ver}-dev.install; \
	done
	dh_auto_install --builddirectory=build --destdir=debian/tmp

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build
	rm -rf debian/tmp

## ipu6-camera-hal 0~git202506270118.c933525~ubuntu24.04.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,13 +41,6 @@
 set(ALGOWRAPPER_DIR     ${MODULES_DIR}/algowrapper)
 set(SANDBOXING_DIR      ${MODULES_DIR}/sandboxing)
 set(IMAGE_PROCESS_DIR   ${SRC_ROOT_DIR}/image_process)
-
-#AAL directories
-if (CAL_BUILD)
-    set(AAL_ROOT_DIR       ${CMAKE_CURRENT_LIST_DIR}/aal)
-    set(JPEG_DIR           ${SRC_ROOT_DIR}/jpeg)
-    set(MEMORY_DIR         ${MODULES_DIR}/memory)
-endif() #CAL_BUILD
 
 if (SUPPORT_LIVE_TUNING)
     #LiveTuning directories
@@ -192,68 +185,16 @@
     set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBCAB_LIBS} ${LIBMOJO_LIBS} ${LIBCAMERA_IPC_LIBS} ${CMAKE_PREFIX_PATH}/librt.a)
 endif() #ENABLE_SANDBOXING
 
-if (CAL_BUILD)
-    message("Chrome enabled ")
-    add_definitions(-DCAL_BUILD -DDUMP_IMAGE)
-    if (SW_JPEG_ENCODE)
-        add_definitions(-DSW_JPEG_ENCODE)
-        include_directories(src/jpeg/sw)
-    else ()
-        include_directories(src/jpeg/chrome)
-    endif()
-
-    if (SW_POST_PROCESSING)
-        include_directories(src/image_process/sw)
-    else ()
-        include_directories(src/image_process/chrome)
-    endif()
-
-    add_subdirectory(aal)
-
-    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${MEMORY_SRCS} ${AAL_SRCS} ${JPEG_SRCS})
-    include_directories(include include/api include/utils include/linux
-        ${USR_INCLUDE_HEADER}/android/system/core/include/
-        ${USR_INCLUDE_HEADER}/ia_imaging
-        ${USR_INCLUDE_HEADER}/usr/lib${IPU_VER}
-        ${USR_INCLUDE_HEADER}/android/hardware/libhardware/include/
-        aal aal/chrome src/iutils src/jpeg
-        modules/memory modules/memory/chrome
-    )
-    find_package(LIBCAMERA_CLIENT)
-    find_package(LIBCAMERA_COMMON)
-    find_package(LIBCAMERA_METADATA)
-    find_package(LIBCAMERA_V4L2_DEVICE)
-    find_package(LIBSYNC)
-    find_package(LIBCBM)
-
-    include_directories(${LIBCAMERA_CLIENT_INCLUDE_DIRS} ${LIBCAMERA_COMMON_INCLUDE_DIRS}
-                        ${LIBCAMERA_METADATA_INCLUDE_DIRS} ${LIBCAMERA_V4L2_DEVICE_INCLUDE_DIRS}
-                        ${LIBSYNC_INCLUDE_DIRS}
-                        ${LIBCBM_INCLUDE_DIRS}
-                        )
-    link_directories(${CMAKE_PREFIX_PATH} ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_METADATA_LIBS}
-                     ${LIBCAMERA_COMMON_LIBS} ${LIBSYNC_LIBS}
-                     ${LIBCBM_LIBS}
-                     )
-
-    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBCAMERA_CLIENT_LIBS} ${LIBCAMERA_COMMON_LIBS}
-                          ${LIBCAMERA_METADATA_LIBS} ${LIBCAMERA_V4L2_DEVICE_LIBS}
-                          ${LIBSYNC_LIBS} jpeg ${CMAKE_PREFIX_PATH}/libyuv.pic.a
-                          ${LIBCBM_LIBS} camera_v4l2_device
-                          )
-endif() #CAL_BUILD
-
-if (NOT CAL_BUILD)
-    message("Linux build")
-    add_definitions(-DSUPPORT_MULTI_PROCESS)
-    add_definitions(-DLINUX_BUILD)
-    include_directories(${MODULES_DIR}/v4l2)
-    find_package(LIBDRM)
-    if(LIBDRM_FOUND AND ("${LIBDRM_VERSION}" VERSION_GREATER_EQUAL 2.4.114))
-        include_directories(${LIBDRM_INCLUDE_DIRS})
-        set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBDRM_LIBS})
-        add_definitions(-DLIBDRM_SUPPORT_MMAP_OFFSET)
-    endif()
+message("Linux build")
+add_definitions(-DSUPPORT_MULTI_PROCESS)
+add_definitions(-DLINUX_BUILD)
+include_directories(${MODULES_DIR}/v4l2)
+find_package(LIBDRM)
+if(LIBDRM_FOUND AND ("${LIBDRM_VERSION}" VERSION_GREATER_EQUAL 2.4.114))
+    include_directories(${LIBDRM_INCLUDE_DIRS})
+    link_directories(${LIBDRM_LIBRARY_DIRS})
+    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBDRM_LIBRARIES})
+    add_definitions(-DLIBDRM_SUPPORT_MMAP_OFFSET)
 endif()
 
 set(LIBCAMHAL_SRCS
@@ -323,39 +264,79 @@
     endif()
 endif()
 
-if (NOT CAL_BUILD)
-    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
-endif()
+set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
 
 # Link libraries, the building will be interrupted if libs/includes not found
     # Link ia_imaging
     find_package(IA_IMAGING)
     set(TARGET_INCLUDE ${TARGET_INCLUDE} ${IA_IMAGING${TARGET_SUFFIX}_INCLUDE_DIRS})
-    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBS})
+    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBRARIES})
+    link_directories(${IA_IMAGING${TARGET_SUFFIX}_LIBRARY_DIRS})
 
     if(USE_PG_LITE_PIPE)
         find_package(LIBGCSS)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBGCSS${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBGCSS${TARGET_SUFFIX}_LIBRARY_DIRS})
         # Include libipu(4) headers
         find_package(LIBIPU)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIPU${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBIPU${TARGET_SUFFIX}_LIBRARY_DIRS})
     else()
         # Link libiacss
         find_package(LIBIACSS)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIACSS${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBIACSS${TARGET_SUFFIX}_LIBRARY_DIRS})
     endif()
 
 #--------------------------- Add libcamhal target  ---------------------------
 
 if (BUILD_CAMHAL_PLUGIN)
-    set(CAMHAL_TARGET ${IPU_VER})
-    set(CAMHAL_STATIC_TARGET ${IPU_VER}_static)
+    set(CAMHAL_TARGET camhal${IPU_VER})
+    set(CAMHAL_STATIC_TARGET camhal${IPU_VER}_static)
 else()
     set(CAMHAL_TARGET camhal)
     set(CAMHAL_STATIC_TARGET camhal_static)
 endif()
 
 # Add libcamhal using the specified sources
+add_library(${CAMHAL_STATIC_TARGET} STATIC ${LIBCAMHAL_SRCS} ${TARGET_SRCS})
+
+if (${CMAKE_VERSION} VERSION_LESS 3.11)
+    add_library(${CAMHAL_TARGET} SHARED ${LIBCAMHAL_SRCS} ${TARGET_SRCS})
+else()
+    add_library(${CAMHAL_TARGET} SHARED $<TARGET_OBJECTS:${CAMHAL_STATIC_TARGET}>)
+endif()
+
+target_include_directories(${CAMHAL_STATIC_TARGET} PRIVATE ${TARGET_INCLUDE})
+target_include_directories(${CAMHAL_TARGET} PRIVATE ${TARGET_INCLUDE})
+target_compile_definitions(${CAMHAL_STATIC_TARGET} PRIVATE ${TARGET_DEFINITIONS})
+target_compile_definitions(${CAMHAL_TARGET} PRIVATE ${TARGET_DEFINITIONS})
+target_link_libraries(${CAMHAL_STATIC_TARGET} PRIVATE ${LIBCAMHAL_LINK_LIBS} ${TARGET_LINK_LIBS})
+target_link_libraries(${CAMHAL_TARGET}  PRIVATE ${LIBCAMHAL_LINK_LIBS} ${TARGET_LINK_LIBS})
+
+if (BUILD_CAMHAL_PLUGIN)
+    set_target_properties(${CAMHAL_STATIC_TARGET} PROPERTIES PREFIX "")
+    set_target_properties(${CAMHAL_TARGET} PROPERTIES PREFIX "")
+    set_target_properties(${CAMHAL_STATIC_TARGET} PROPERTIES OUTPUT_NAME ${IPU_VER})
+    set_target_properties(${CAMHAL_TARGET} PROPERTIES OUTPUT_NAME ${IPU_VER})
+else()
+    set_target_properties(${CAMHAL_STATIC_TARGET} PROPERTIES OUTPUT_NAME ${CAMHAL_TARGET})
+    set_target_properties(${CAMHAL_TARGET} PROPERTIES SOVERSION 0)
+    set_target_properties(${CAMHAL_TARGET} PROPERTIES VERSION "0.0.0")
+    set_target_properties(${CAMHAL_TARGET} PROPERTIES OUTPUT_NAME ${CAMHAL_TARGET})
+endif()
+
+
+#--------------------------- Install settings ---------------------------
+if (NOT BUILD_CAMHAL_PLUGIN)
+    # Install headers
+    install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libcamhal)
+    if (SUPPORT_LIVE_TUNING)
+        install(FILES modules/livetune/LiveTuning.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libcamhal/api)
+    endif() #SUPPORT_LIVE_TUNING
+endif()
+# Install configure files, by default ipu4 is used
+message("Install camera configure files for ${IPU_VER}")

=== src/CMakeLists.txt ===
#
#  Copyright (C) 2018-2019 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

add_subdirectory(3a)
add_subdirectory(core)
add_subdirectory(hal)
add_subdirectory(iutils)
add_subdirectory(scheduler)
add_subdirectory(metadata)
add_subdirectory(platformdata)
add_subdirectory(v4l2)
add_subdirectory(image_process)
if(FACE_DETECTION)
    add_subdirectory(fd)
endif() #FACE_DETECTION

=== src/fd/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

# Use -DFACE_DETECTION to enable the face detection feature
if (NOT ENABLE_SANDBOXING)
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        ${ALGOWRAPPER_DIR}/IntelFaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
#---------------------------- include the header ----------------------------
    include_directories(${USR_INCLUDE_HEADER}/ia_imaging
                        ${ALGOWRAPPER_DIR}/IntelFaceDetection.h
                        ${IUTILS_DIR}
                        include/utils)
#---------------------------- static library ----------------------------
    add_library(face_detection STATIC ${FACE_DETECTION_SRCS})
else ()
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
endif()

include_directories(${MODULES_DIR}/v4l2)

=== src/v4l2/CMakeLists.txt ===
#
#  Copyright (C) 2017,2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set (V4L2_SRCS
    ${V4L2_DIR}/MediaControl.cpp
    ${V4L2_DIR}/V4l2DeviceFactory.cpp
    ${V4L2_DIR}/SysCall.cpp
    ${V4L2_DIR}/NodeInfo.cpp
    CACHE INTERNAL "v4l2 sources"
    )

set(V4L2_SRCS
    ${V4L2_SRCS}
    ${MODULES_DIR}/v4l2/v4l2_device.cc
    ${MODULES_DIR}/v4l2/v4l2_subdevice.cc
    ${MODULES_DIR}/v4l2/v4l2_video_node.cc
    CACHE INTERNAL "v4l2 sources"
    )

=== debian/changelog ===
ipu6-camera-hal (0~git202506270118.c933525~ubuntu24.04.4) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Mon, 13 Oct 2025 04:02:24 +0000

## ipu6-camera-hal 0~git202506270118.c933525~ubuntu24.04.5

=== modules/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

    if (ENABLE_SANDBOXING)
        add_subdirectory(sandboxing)
    else()
        add_subdirectory(algowrapper)
    endif() #ENABLE_SANDBOXING

if (USE_PG_LITE_PIPE)
    add_subdirectory(ia_cipr)
endif() #USE_PG_LITE_PIPE

if (SUPPORT_LIVE_TUNING)
    add_subdirectory(livetune)
endif() #SUPPORT_LIVE_TUNING

=== src/image_process/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

set(IMAGE_PROCESS_SRCS
    ${IMAGE_PROCESS_DIR}/ImageConverter.cpp
    ${IMAGE_PROCESS_DIR}/ImageScalerCore.cpp
    CACHE INTERNAL "image_process sources"
    )

=== debian/changelog ===
ipu6-camera-hal (0~git202506270118.c933525~ubuntu24.04.5) noble; urgency=low

  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Thu, 06 Nov 2025 09:52:50 +0000
